using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class AddContact : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            txtFirstName.Focus();
            if (Request.QueryString["Id"] != null)
            {
                btnSave.Text = "Update";
                GetDetailsById();         
            }
        }
    }
    //For Getting Details By Id
    private void GetDetailsById()
    {
        AddressBookBo objAddressBookBo = new AddressBookBo();
        AddressBookBAL objAddressBookBAL = new AddressBookBAL();
        try
        {
            objAddressBookBo.Id = int.Parse(Request.QueryString["Id"].ToString());
            DataSet ds = new DataSet();
            ds = objAddressBookBAL.GetDetailsById(objAddressBookBo);
            if (ds != null)
            {
                txtFirstName.Text = ds.Tables[0].Rows[0]["FirstName"].ToString();
                txtLastName.Text = ds.Tables[0].Rows[0]["LastName"].ToString();
                txtPhone.Text = ds.Tables[0].Rows[0]["Phone"].ToString();
                txtEmail.Text = ds.Tables[0].Rows[0]["Email"].ToString();
                txtAddress.Text = ds.Tables[0].Rows[0]["Address"].ToString();
                txtOfficeName.Text = ds.Tables[0].Rows[0]["OfficeName"].ToString();
                txtOfficePhone.Text = ds.Tables[0].Rows[0]["OfficePhone"].ToString();
                                
            }
            else
            {
                lblMsg.Text = "No Data Found";
            }
        }
        catch
        {
            throw;
        }
    }
    //To add new Address
    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (Request.QueryString["Id"] != null)
        {
            UpdateDetails();
        }
        else
        {
            InsertDetails();
        }
    }
    private void InsertDetails()
    {
        try
        {
            AddressBookBo objAddressBookBo = new AddressBookBo();
            AddressBookBAL objAddressBookBAL = new AddressBookBAL();
            objAddressBookBo.EmpId = int.Parse(Session["EmpId"].ToString());
            objAddressBookBo.FirstName = txtFirstName.Text.Trim();
            objAddressBookBo.LastName = txtLastName.Text.Trim();
            objAddressBookBo.Phone = txtPhone.Text.Trim();
            objAddressBookBo.Email = txtEmail.Text.Trim();
            objAddressBookBo.Address = txtAddress.Text;
            objAddressBookBo.OfficeName = txtOfficeName.Text.Trim();
            objAddressBookBo.OfficePhone = txtOfficePhone.Text.Trim();
            
            objAddressBookBAL.InsertDetails(objAddressBookBo);
            Server.Transfer("ViewAddressBook.aspx");
        }
        catch
        {
            throw;
        }
    }
    private void UpdateDetails()
    {
        try
        {
            AddressBookBo objAddressBookBo = new AddressBookBo();
            AddressBookBAL objAddressBookBAL = new AddressBookBAL();
            objAddressBookBo.Id = int.Parse(Request.QueryString["Id"].ToString());
            objAddressBookBo.FirstName = txtFirstName.Text.Trim();
            objAddressBookBo.LastName = txtLastName.Text.Trim();
            objAddressBookBo.Phone = txtPhone.Text.Trim();
            objAddressBookBo.Email = txtEmail.Text.Trim();
            objAddressBookBo.Address = txtAddress.Text;
            objAddressBookBo.OfficeName = txtOfficeName.Text.Trim();
            objAddressBookBo.OfficePhone = txtOfficePhone.Text.Trim();

            objAddressBookBAL.UpdateDetails(objAddressBookBo);
            Server.Transfer("ViewAddressBook.aspx");
        }
        catch
        {
            throw;
        }
    }

    protected void btnCancel_Click(object sender, EventArgs e)
    {
        Server.Transfer("ViewAddressBook.aspx");
    }
}
