using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
/// <summary>
/// Summary description for AddressBookDAL
/// </summary>
public class AddressBookDAL
{
    SqlConnection SqlCon = new SqlConnection(ConfigurationManager.AppSettings["ConStr"]); 
	public AddressBookDAL()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    //For Getting Details
    public DataSet GetData(AddressBookBo objAddressBookBo)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblAddressBook", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'G';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@EmpId", SqlDbType.Int,4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objAddressBookBo.EmpId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //For Getting Details By Id
    public DataSet GetDetailsById(AddressBookBo objAddressBookBo)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblAddressBook", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'A';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@Id", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objAddressBookBo.Id;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
        
    }
    //For Inserting into AddressBook
    public int InsertDetails(AddressBookBo objAddressBookBo)
    {
        try
        {
            SqlCommand SqlInsertCmd = new SqlCommand("sp_tblAddressBook", SqlCon);
            SqlCon.Open();
            SqlInsertCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlInsertCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'I';

            SqlParameter p2 = SqlInsertCmd.Parameters.Add("EmpId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objAddressBookBo.EmpId;

            SqlParameter p3 = SqlInsertCmd.Parameters.Add("@FirstName", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objAddressBookBo.FirstName;

            SqlParameter p4 = SqlInsertCmd.Parameters.Add("@LastName", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objAddressBookBo.LastName;

            SqlParameter p5 = SqlInsertCmd.Parameters.Add("@Phone", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objAddressBookBo.Phone;

            SqlParameter p6 = SqlInsertCmd.Parameters.Add("@Email", SqlDbType.VarChar, 50);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objAddressBookBo.Email;

            SqlParameter p7 = SqlInsertCmd.Parameters.Add("@Address", SqlDbType.VarChar, 100);
            p7.Direction = ParameterDirection.Input;
            p7.Value = objAddressBookBo.Address;

            SqlParameter p8 = SqlInsertCmd.Parameters.Add("@OfficeName", SqlDbType.VarChar, 50);
            p8.Direction = ParameterDirection.Input;
            p8.Value = objAddressBookBo.OfficeName;

            SqlParameter p9 = SqlInsertCmd.Parameters.Add("@OfficePhone", SqlDbType.VarChar, 50);
            p9.Direction = ParameterDirection.Input;
            p9.Value = objAddressBookBo.OfficePhone;
            
            return SqlInsertCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Updating Address Book
    public int UpdateDetails(AddressBookBo objAddressBookBo)
    {
        try
        {
            SqlCommand SqlUpdateCmd = new SqlCommand("sp_tblAddressBook", SqlCon);
            SqlCon.Open();
            SqlUpdateCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlUpdateCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'U';

            SqlParameter p2 = SqlUpdateCmd.Parameters.Add("Id", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objAddressBookBo.Id;

            SqlParameter p3 = SqlUpdateCmd.Parameters.Add("@FirstName", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objAddressBookBo.FirstName;

            SqlParameter p4 = SqlUpdateCmd.Parameters.Add("@LastName", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objAddressBookBo.LastName;

            SqlParameter p5 = SqlUpdateCmd.Parameters.Add("@Phone", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objAddressBookBo.Phone;

            SqlParameter p6 = SqlUpdateCmd.Parameters.Add("@Email", SqlDbType.VarChar, 50);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objAddressBookBo.Email;

            SqlParameter p7 = SqlUpdateCmd.Parameters.Add("@Address", SqlDbType.VarChar, 100);
            p7.Direction = ParameterDirection.Input;
            p7.Value = objAddressBookBo.Address;

            SqlParameter p8 = SqlUpdateCmd.Parameters.Add("@OfficeName", SqlDbType.VarChar, 50);
            p8.Direction = ParameterDirection.Input;
            p8.Value = objAddressBookBo.OfficeName;

            SqlParameter p9 = SqlUpdateCmd.Parameters.Add("@OfficePhone", SqlDbType.VarChar, 50);
            p9.Direction = ParameterDirection.Input;
            p9.Value = objAddressBookBo.OfficePhone;

            return SqlUpdateCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Deleting from Address Book
    public int DeleteDetails(AddressBookBo objAddressBookBo)
    {
        try
        {
            SqlCommand SqlDeleteCmd = new SqlCommand("sp_tblAddressBook", SqlCon);
            SqlCon.Open();
            SqlDeleteCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlDeleteCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'D';

            SqlParameter p2 = SqlDeleteCmd.Parameters.Add("Id", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objAddressBookBo.Id;

            return SqlDeleteCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }

    }
}
