using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
/// <summary>
/// Summary description for LeavesDAL
/// </summary>
public class LeavesDAL
{
    SqlConnection SqlCon = new SqlConnection(ConfigurationManager.AppSettings["ConStr"]); 
	public LeavesDAL()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    //For Getting Leaves
    public DataSet GetData()
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblLeaves", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'G';

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting Details By Id
    public DataSet GetDataById(LeavesBO objLeavesBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblLeaves", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'A';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@Id", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objLeavesBO.Id;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //For Getting Details By EmpId
    public DataSet GetDataByEmpId(LeavesBO objLeavesBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblLeaves", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'B';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@EmpId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objLeavesBO.EmpId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //For Create New Leave
    public int CreateLeave(LeavesBO objLeavesBO)
    {
        try
        {
            SqlCommand SqlInsertCmd = new SqlCommand("sp_tblLeaves", SqlCon);
            SqlCon.Open();
            SqlInsertCmd.CommandType=CommandType.StoredProcedure;

            SqlParameter p1=SqlInsertCmd.Parameters.Add("@Type",SqlDbType.Char,1);
            p1.Direction=ParameterDirection.Input;
            p1.Value='I';

            SqlParameter p2 = SqlInsertCmd.Parameters.Add("@EmpId", SqlDbType.Int, 4);
            p2.Direction=ParameterDirection.Input;
            p2.Value = objLeavesBO.EmpId;

            SqlParameter p3 = SqlInsertCmd.Parameters.Add("@Purpose", SqlDbType.VarChar,50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objLeavesBO.Purpose;

            SqlParameter p4 = SqlInsertCmd.Parameters.Add("@FromDate", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objLeavesBO.FromDate;

            SqlParameter p5 = SqlInsertCmd.Parameters.Add("@ToDate", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objLeavesBO.ToDate;

            SqlParameter p6 = SqlInsertCmd.Parameters.Add("@EmpName", SqlDbType.VarChar, 50);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objLeavesBO.EmpName;

            return SqlInsertCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Updating Leaves status
    public int UpdateLeaves(LeavesBO objLeavesBO)
    {
        try
        {
            SqlCommand SqlUpdateCmd = new SqlCommand("sp_tblLeaves", SqlCon);
            SqlCon.Open();
            SqlUpdateCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlUpdateCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'U';

            SqlParameter p2 = SqlUpdateCmd.Parameters.Add("@Id", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objLeavesBO.Id;

            SqlParameter p3 = SqlUpdateCmd.Parameters.Add("@Status", SqlDbType.Char, 1);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objLeavesBO.Status;

            return SqlUpdateCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
    }
}
