using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
/// <summary>
/// Summary description for MessagesDAL
/// </summary>
public class MessagesDAL
{
    SqlConnection SqlCon = new SqlConnection(ConfigurationManager.AppSettings["ConStr"]); 
	public MessagesDAL()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    //For getting Messages
    public DataSet GetData()
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblMessages", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "G";

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting Messages By MsgId
    public DataSet GetDataByMsgId(MessagesBO objMessagesBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblMessages", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "C";

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@MsgId", SqlDbType.Int,4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objMessagesBO.MsgId;
            
            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting Messages By Id
    public DataSet GetDataById(MessagesBO objMessagesBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblMessages", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "B";

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@Reciever", SqlDbType.VarChar,50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objMessagesBO.Reciever;

            SqlParameter p3 = SqlDa.SelectCommand.Parameters.Add("@GroupName", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objMessagesBO.GroupName;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //To create new message For Individual
    public int CreateMsgForIndividual(MessagesBO objMessagesBO)
    {
        try
        {
            SqlCommand SqlInsertCmd = new SqlCommand("sp_tblMessages", SqlCon);
            SqlCon.Open();
            SqlInsertCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlInsertCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "I";

            SqlParameter p2 = SqlInsertCmd.Parameters.Add("@Sender", SqlDbType.VarChar, 50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objMessagesBO.Sender;

            SqlParameter p3 = SqlInsertCmd.Parameters.Add("@Reciever", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objMessagesBO.Reciever;

            SqlParameter p4 = SqlInsertCmd.Parameters.Add("@Subject", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objMessagesBO.Subject;

            SqlParameter p5 = SqlInsertCmd.Parameters.Add("@Message", SqlDbType.VarChar, 500);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objMessagesBO.Message;

            SqlParameter p6 = SqlInsertCmd.Parameters.Add("@MessageDate", SqlDbType.VarChar, 50);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objMessagesBO.MessageDate;

            return SqlInsertCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //To create new message For Group
    public int CreateMsgForGroup(MessagesBO objMessagesBO)
    {
        try
        {
            SqlCommand SqlInsertCmd = new SqlCommand("sp_tblMessages", SqlCon);
            SqlCon.Open();
            SqlInsertCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlInsertCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "A";

            SqlParameter p2 = SqlInsertCmd.Parameters.Add("@Sender", SqlDbType.VarChar, 50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objMessagesBO.Sender;
                        
            SqlParameter p3 = SqlInsertCmd.Parameters.Add("@Subject", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objMessagesBO.Subject;

            SqlParameter p4 = SqlInsertCmd.Parameters.Add("@Message", SqlDbType.VarChar, 500);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objMessagesBO.Message;

            SqlParameter p5 = SqlInsertCmd.Parameters.Add("@GroupName", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objMessagesBO.GroupName;

            SqlParameter p6 = SqlInsertCmd.Parameters.Add("@MessageDate", SqlDbType.VarChar, 50);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objMessagesBO.MessageDate;

            return SqlInsertCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Deleting the Messages From Inbox
    public int DeleteMessage(MessagesBO objMessagesBO)
    {
        try
        {
            SqlCommand SqlDeleteCmd = new SqlCommand("sp_tblMessages", SqlCon);
            SqlCon.Open();
            SqlDeleteCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlDeleteCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "D";

            SqlParameter p2 = SqlDeleteCmd.Parameters.Add("@MsgId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objMessagesBO.MsgId;

            return SqlDeleteCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
}
