using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
/// <summary>
/// Summary description for ScheduledWorkDAL
/// </summary>
public class ScheduledWorkDAL
{
    SqlConnection SqlCon = new SqlConnection(ConfigurationManager.AppSettings["ConStr"]); 
	public ScheduledWorkDAL()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    //For Getting Work Details
    public DataSet GetData()
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'G';
            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting Work Information from tblScheduler With AdminId(Total Reports)
    public DataSet GetDataByAdminId(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'C';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@AdminId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.AdminId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting ToDay's Work Information from tblScheduler With AdminId
    public DataSet GetTodaysWorkReport(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'T';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@AdminId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.AdminId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //For Getting This Week's Work Information from tblScheduler With AdminId
    public DataSet GetThisWeekWorkReport(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'W';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@AdminId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.AdminId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //For Getting This Month's Work Information from tblScheduler With AdminId
    public DataSet GetThisMonthWorkReport(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'M';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@AdminId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.AdminId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //For Getting Work Details By Id
    public DataSet GetWorkDetailsById(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'A';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@UserId", SqlDbType.Int,4);
            p2.Direction = ParameterDirection.Input;
            p2.Value =objScheduledWorkBO.UserId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting AssinedWorks Based on UserId And Status
    public DataSet GetAssignedWorks(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblScheduler", SqlCon);
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet ds = new DataSet();

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'B';

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@UserId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.UserId;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //To Create Work
    public int CreateWork(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlCommand SqlInsertCmd = new SqlCommand("sp_tblScheduler", SqlCon);
            SqlCon.Open();
            SqlInsertCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlInsertCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'I';

            SqlParameter p2 = SqlInsertCmd.Parameters.Add("@AdminId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.AdminId;

            SqlParameter p3 = SqlInsertCmd.Parameters.Add("@UserId", SqlDbType.Int, 4);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objScheduledWorkBO.UserId;

            SqlParameter p4 = SqlInsertCmd.Parameters.Add("@WorkAssignedDate", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objScheduledWorkBO.WorkAssignedDate;

            SqlParameter p5 = SqlInsertCmd.Parameters.Add("@AssignedWork", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objScheduledWorkBO.AssignedWork;

            return SqlInsertCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Updating TblScheduler
    public int UpdateScheduler(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlCommand SqlUpdateCmd = new SqlCommand("sp_tblScheduler", SqlCon);
            SqlCon.Open();
            SqlUpdateCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlUpdateCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'U';

            SqlParameter p2 = SqlUpdateCmd.Parameters.Add("@Status", SqlDbType.Char, 1);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.Status;

            SqlParameter p3 = SqlUpdateCmd.Parameters.Add("@ReportedDate", SqlDbType.VarChar,50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objScheduledWorkBO.ReportedDate;

            SqlParameter p4 = SqlUpdateCmd.Parameters.Add("@UserId", SqlDbType.Int,4);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objScheduledWorkBO.UserId;

            SqlParameter p5 = SqlUpdateCmd.Parameters.Add("@AssignedWork", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objScheduledWorkBO.AssignedWork;

            return SqlUpdateCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Deleting From tblScheduler
    public int DeleteFromScheduler(ScheduledWorkBO objScheduledWorkBO)
    {
        try
        {
            SqlCommand SqlDeleteCmd = new SqlCommand("sp_tblScheduler", SqlCon);
            SqlCon.Open();
            SqlDeleteCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlDeleteCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = 'D';

            SqlParameter p2 = SqlDeleteCmd.Parameters.Add("@SchedulerId", SqlDbType.Int,4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objScheduledWorkBO.SchedulerId;

            return SqlDeleteCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
    }

}
