using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

/// <summary>
/// Summary description for UserManagementDAL
/// </summary>
public class UserManagementDAL
{
    SqlConnection SqlCon = new SqlConnection(ConfigurationManager.AppSettings["ConStr"]); 
	public UserManagementDAL()
	{
		//
		// TODO: Add constructor logic here
		//
	}
    //For Checking Login
    public DataSet CheckLogin(UserManagementBO objUserManagementBO)
    {
        SqlCommand SqlCmd = new SqlCommand("sp_tblEmployee", SqlCon);
        SqlCmd.CommandType = CommandType.StoredProcedure;
                
        SqlParameter p1 = SqlCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
        p1.Direction = ParameterDirection.Input;
        p1.Value = "G";

        SqlParameter p2 = SqlCmd.Parameters.Add("@UserName", SqlDbType.VarChar, 50);
        p2.Direction = ParameterDirection.Input;
        p2.Value = objUserManagementBO.UserName;

        //SqlParameter p3 = SqlCmd.Parameters.Add("@Password", SqlDbType.VarChar, 50);
        //p3.Direction = ParameterDirection.Input;
        //p3.Value = objUserManagementBO.Password;

        SqlDataAdapter SqlDa = new SqlDataAdapter(SqlCmd);
        DataSet ds = new DataSet();
        SqlDa.Fill(ds);
        return ds;

    }
    //For Getting UserNames
    public DataSet GetUserNames(UserManagementBO objUserManagementBO)
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblEmployee", SqlCon);
            DataSet ds = new DataSet();
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "Q";

            SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@UserName", SqlDbType.VarChar,50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objUserManagementBO.UserName; ;

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            return null;
        }
    }
    //For Getting Employee Details
    public DataSet GetDetails()
    {
        SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblEmployee", SqlCon);
        DataSet ds = new DataSet();
        SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;

        SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
        p1.Direction = ParameterDirection.Input;
        p1.Value = "A";

        SqlDa.Fill(ds);
        return ds;
    }
    //For Getting Details by EmployeeId
    public DataSet GetDetailsById(UserManagementBO objUserManagementBO)
    {
        SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblEmployee", SqlCon);
        DataSet ds = new DataSet();
        SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;

        SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
        p1.Direction = ParameterDirection.Input;
        p1.Value = "B";

        SqlParameter p2 = SqlDa.SelectCommand.Parameters.Add("@EmpId", SqlDbType.Int, 4);
        p2.Direction = ParameterDirection.Input;
        p2.Value = objUserManagementBO.EmpId;

        SqlDa.Fill(ds);
        return ds;
    }
    //For Getting admin Id's
    //public DataSet GetAdminIds()
    //{
    //    try
    //    {
    //        SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblEmployee", SqlCon);
    //        DataSet ds = new DataSet();
    //        SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;

    //        SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
    //        p1.Direction = ParameterDirection.Input;
    //        p1.Value = "C";
                        
    //        SqlDa.Fill(ds);
    //        return ds;
    //    }
    //    catch
    //    {
    //        throw;
    //    }
    //}
    //For Getting User Id's
    public DataSet GetUserIds()
    {
        try
        {
            SqlDataAdapter SqlDa = new SqlDataAdapter("sp_tblEmployee", SqlCon);
            DataSet ds = new DataSet();
            SqlDa.SelectCommand.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlDa.SelectCommand.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "E";

            SqlDa.Fill(ds);
            return ds;
        }
        catch
        {
            throw;
        }
    }
    //To Create An Employee
    public int CreateEmployee(UserManagementBO objUserManagementBO)
    {
        try
        {
            SqlCommand SqlInsertCmd = new SqlCommand("sp_tblEmployee", SqlCon);
            SqlCon.Open();
            SqlInsertCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlInsertCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "I";

            SqlParameter p2 = SqlInsertCmd.Parameters.Add("@FirstName", SqlDbType.VarChar, 50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objUserManagementBO.FirstName;

            SqlParameter p3 = SqlInsertCmd.Parameters.Add("@LastName", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objUserManagementBO.LastName;

            SqlParameter p4 = SqlInsertCmd.Parameters.Add("@Phone", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objUserManagementBO.Phone;

            SqlParameter p5 = SqlInsertCmd.Parameters.Add("@Email", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objUserManagementBO.Email;

            SqlParameter p6 = SqlInsertCmd.Parameters.Add("@Address", SqlDbType.VarChar, 100);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objUserManagementBO.Address;

            SqlParameter p7 = SqlInsertCmd.Parameters.Add("@UserName", SqlDbType.VarChar, 50);
            p7.Direction = ParameterDirection.Input;
            p7.Value = objUserManagementBO.UserName; ;

            SqlParameter p8 = SqlInsertCmd.Parameters.Add("@Password", SqlDbType.VarChar, 50);
            p8.Direction = ParameterDirection.Input;
            p8.Value = objUserManagementBO.Password;

            SqlParameter p9 = SqlInsertCmd.Parameters.Add("@UserType", SqlDbType.Char, 1);
            p9.Direction = ParameterDirection.Input;
            p9.Value = objUserManagementBO.UserType;

            SqlParameter p10 = SqlInsertCmd.Parameters.Add("@BranchName", SqlDbType.VarChar, 50);
            p10.Direction = ParameterDirection.Input;
            p10.Value = objUserManagementBO.BranchName;

            SqlParameter p11 = SqlInsertCmd.Parameters.Add("@GroupName", SqlDbType.VarChar, 50);
            p11.Direction = ParameterDirection.Input;
            p11.Value = objUserManagementBO.GroupName;

            return SqlInsertCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
   
    //For Updating Employee Account
    public int UpdateEmpAccount(UserManagementBO objUserManagementBO)
    {
        try
        {
            SqlCommand SqlUpdateCmd = new SqlCommand("sp_tblEmployee", SqlCon);
            SqlCon.Open();
            SqlUpdateCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlUpdateCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "U";

            SqlParameter p2 = SqlUpdateCmd.Parameters.Add("@FirstName", SqlDbType.VarChar, 50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objUserManagementBO.FirstName;

            SqlParameter p3 = SqlUpdateCmd.Parameters.Add("@LastName", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objUserManagementBO.LastName;

            SqlParameter p4 = SqlUpdateCmd.Parameters.Add("@Phone", SqlDbType.VarChar, 50);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objUserManagementBO.Phone;

            SqlParameter p5 = SqlUpdateCmd.Parameters.Add("@Email", SqlDbType.VarChar, 50);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objUserManagementBO.Email;

            SqlParameter p6 = SqlUpdateCmd.Parameters.Add("@Address", SqlDbType.VarChar, 100);
            p6.Direction = ParameterDirection.Input;
            p6.Value = objUserManagementBO.Address;

            SqlParameter p7 = SqlUpdateCmd.Parameters.Add("@UserName", SqlDbType.VarChar, 50);
            p7.Direction = ParameterDirection.Input;
            p7.Value = objUserManagementBO.UserName; ;

            SqlParameter p8 = SqlUpdateCmd.Parameters.Add("@Password", SqlDbType.VarChar, 50);
            p8.Direction = ParameterDirection.Input;
            p8.Value = objUserManagementBO.Password;

            SqlParameter p9 = SqlUpdateCmd.Parameters.Add("@UserType", SqlDbType.Char, 1);
            p9.Direction = ParameterDirection.Input;
            p9.Value = objUserManagementBO.UserType;

            SqlParameter p10 = SqlUpdateCmd.Parameters.Add("@BranchName", SqlDbType.VarChar, 50);
            p10.Direction = ParameterDirection.Input;
            p10.Value = objUserManagementBO.BranchName;

            SqlParameter p11 = SqlUpdateCmd.Parameters.Add("@GroupName", SqlDbType.VarChar, 50);
            p11.Direction = ParameterDirection.Input;
            p11.Value = objUserManagementBO.GroupName;

            SqlParameter p12 = SqlUpdateCmd.Parameters.Add("@EmpId", SqlDbType.Int, 4);
            p12.Direction = ParameterDirection.Input;
            p12.Value = objUserManagementBO.EmpId;

            return SqlUpdateCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Deleting Employee Account
    public int DeleteEmpAccount(UserManagementBO objUserManagementBO)
    {
        try
        {
            SqlCommand SqlDeleteCmd = new SqlCommand("sp_tblEmployee", SqlCon);
            SqlCon.Open();
            SqlDeleteCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlDeleteCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "D";

            SqlParameter p2 = SqlDeleteCmd.Parameters.Add("@EmpId", SqlDbType.Int, 4);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objUserManagementBO.EmpId;

            return SqlDeleteCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }

    }
    //For Updating Password
    public int UpdatePassword(UserManagementBO objUserManagementBO)
    {
        try
        {
            SqlCommand SqlUpdateCmd = new SqlCommand("sp_tblEmployee", SqlCon);
            SqlCon.Open();
            SqlUpdateCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlUpdateCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "Z";

            SqlParameter p2 = SqlUpdateCmd.Parameters.Add("@Password", SqlDbType.VarChar, 50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objUserManagementBO.Password;

            SqlParameter p3 = SqlUpdateCmd.Parameters.Add("@EmpId", SqlDbType.Int, 4);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objUserManagementBO.EmpId;

            return SqlUpdateCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
        finally
        {
            SqlCon.Close();
        }
    }
    //For Updating User personal Information
    public int UpdatePersonalInfo(UserManagementBO objUserManagementBO)
    {
        try
        {
            SqlCommand SqlUpdateCmd = new SqlCommand("sp_tblEmployee", SqlCon);
            SqlCon.Open();
            SqlUpdateCmd.CommandType = CommandType.StoredProcedure;

            SqlParameter p1 = SqlUpdateCmd.Parameters.Add("@Type", SqlDbType.Char, 1);
            p1.Direction = ParameterDirection.Input;
            p1.Value = "Y";

            SqlParameter p2 = SqlUpdateCmd.Parameters.Add("@Phone", SqlDbType.VarChar, 50);
            p2.Direction = ParameterDirection.Input;
            p2.Value = objUserManagementBO.Phone;

            SqlParameter p3 = SqlUpdateCmd.Parameters.Add("@Email", SqlDbType.VarChar, 50);
            p3.Direction = ParameterDirection.Input;
            p3.Value = objUserManagementBO.Email;

            SqlParameter p4 = SqlUpdateCmd.Parameters.Add("@Address", SqlDbType.VarChar, 100);
            p4.Direction = ParameterDirection.Input;
            p4.Value = objUserManagementBO.Address;

            SqlParameter p5 = SqlUpdateCmd.Parameters.Add("@EmpId", SqlDbType.Int, 4);
            p5.Direction = ParameterDirection.Input;
            p5.Value = objUserManagementBO.EmpId;

            return SqlUpdateCmd.ExecuteNonQuery();
        }
        catch
        {
            throw;
        }
    }

    
}
